import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../../common";
export interface IMXFarmInterface extends utils.Interface {
    functions: {
        "collateralToken()": FunctionFragment;
        "getIMXLiquidity()": FunctionFragment;
        "getUnderlyingShortReserves()": FunctionFragment;
        "impermaxBorrow(address,address,uint256,bytes)": FunctionFragment;
        "impermaxRedeem(address,uint256,bytes)": FunctionFragment;
        "isInitialized()": FunctionFragment;
        "pair()": FunctionFragment;
        "sBorrowable()": FunctionFragment;
        "short()": FunctionFragment;
        "uBorrowable()": FunctionFragment;
        "underlying()": FunctionFragment;
        "uniPair()": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "collateralToken" | "getIMXLiquidity" | "getUnderlyingShortReserves" | "impermaxBorrow" | "impermaxRedeem" | "isInitialized" | "pair" | "sBorrowable" | "short" | "uBorrowable" | "underlying" | "uniPair"): FunctionFragment;
    encodeFunctionData(functionFragment: "collateralToken", values?: undefined): string;
    encodeFunctionData(functionFragment: "getIMXLiquidity", values?: undefined): string;
    encodeFunctionData(functionFragment: "getUnderlyingShortReserves", values?: undefined): string;
    encodeFunctionData(functionFragment: "impermaxBorrow", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BytesLike>
    ]): string;
    encodeFunctionData(functionFragment: "impermaxRedeem", values: [
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BytesLike>
    ]): string;
    encodeFunctionData(functionFragment: "isInitialized", values?: undefined): string;
    encodeFunctionData(functionFragment: "pair", values?: undefined): string;
    encodeFunctionData(functionFragment: "sBorrowable", values?: undefined): string;
    encodeFunctionData(functionFragment: "short", values?: undefined): string;
    encodeFunctionData(functionFragment: "uBorrowable", values?: undefined): string;
    encodeFunctionData(functionFragment: "underlying", values?: undefined): string;
    encodeFunctionData(functionFragment: "uniPair", values?: undefined): string;
    decodeFunctionResult(functionFragment: "collateralToken", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getIMXLiquidity", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getUnderlyingShortReserves", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "impermaxBorrow", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "impermaxRedeem", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isInitialized", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pair", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "sBorrowable", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "short", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "uBorrowable", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "underlying", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "uniPair", data: BytesLike): Result;
    events: {
        "HarvestedToken(address,uint256)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "HarvestedToken"): EventFragment;
}
export interface HarvestedTokenEventObject {
    token: string;
    amount: BigNumber;
}
export type HarvestedTokenEvent = TypedEvent<[
    string,
    BigNumber
], HarvestedTokenEventObject>;
export type HarvestedTokenEventFilter = TypedEventFilter<HarvestedTokenEvent>;
export interface IMXFarm extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: IMXFarmInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        collateralToken(overrides?: CallOverrides): Promise<[string]>;
        getIMXLiquidity(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            reserveA: BigNumber;
            reserveB: BigNumber;
        }>;
        impermaxBorrow(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, arg2: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        impermaxRedeem(arg0: PromiseOrValue<string>, redeemAmount: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        isInitialized(overrides?: CallOverrides): Promise<[boolean]>;
        pair(overrides?: CallOverrides): Promise<[string]>;
        sBorrowable(overrides?: CallOverrides): Promise<[string]>;
        short(overrides?: CallOverrides): Promise<[string]>;
        uBorrowable(overrides?: CallOverrides): Promise<[string]>;
        underlying(overrides?: CallOverrides): Promise<[string]>;
        uniPair(overrides?: CallOverrides): Promise<[string]>;
    };
    collateralToken(overrides?: CallOverrides): Promise<string>;
    getIMXLiquidity(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    getUnderlyingShortReserves(overrides?: CallOverrides): Promise<[
        BigNumber,
        BigNumber
    ] & {
        reserveA: BigNumber;
        reserveB: BigNumber;
    }>;
    impermaxBorrow(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, arg2: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    impermaxRedeem(arg0: PromiseOrValue<string>, redeemAmount: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    isInitialized(overrides?: CallOverrides): Promise<boolean>;
    pair(overrides?: CallOverrides): Promise<string>;
    sBorrowable(overrides?: CallOverrides): Promise<string>;
    short(overrides?: CallOverrides): Promise<string>;
    uBorrowable(overrides?: CallOverrides): Promise<string>;
    underlying(overrides?: CallOverrides): Promise<string>;
    uniPair(overrides?: CallOverrides): Promise<string>;
    callStatic: {
        collateralToken(overrides?: CallOverrides): Promise<string>;
        getIMXLiquidity(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber
        ] & {
            collateral: BigNumber;
            price0: BigNumber;
            price1: BigNumber;
            amount0: BigNumber;
            amount1: BigNumber;
        }>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            reserveA: BigNumber;
            reserveB: BigNumber;
        }>;
        impermaxBorrow(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, arg2: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<void>;
        impermaxRedeem(arg0: PromiseOrValue<string>, redeemAmount: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<void>;
        isInitialized(overrides?: CallOverrides): Promise<boolean>;
        pair(overrides?: CallOverrides): Promise<string>;
        sBorrowable(overrides?: CallOverrides): Promise<string>;
        short(overrides?: CallOverrides): Promise<string>;
        uBorrowable(overrides?: CallOverrides): Promise<string>;
        underlying(overrides?: CallOverrides): Promise<string>;
        uniPair(overrides?: CallOverrides): Promise<string>;
    };
    filters: {
        "HarvestedToken(address,uint256)"(token?: PromiseOrValue<string> | null, amount?: null): HarvestedTokenEventFilter;
        HarvestedToken(token?: PromiseOrValue<string> | null, amount?: null): HarvestedTokenEventFilter;
    };
    estimateGas: {
        collateralToken(overrides?: CallOverrides): Promise<BigNumber>;
        getIMXLiquidity(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<BigNumber>;
        impermaxBorrow(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, arg2: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        impermaxRedeem(arg0: PromiseOrValue<string>, redeemAmount: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        isInitialized(overrides?: CallOverrides): Promise<BigNumber>;
        pair(overrides?: CallOverrides): Promise<BigNumber>;
        sBorrowable(overrides?: CallOverrides): Promise<BigNumber>;
        short(overrides?: CallOverrides): Promise<BigNumber>;
        uBorrowable(overrides?: CallOverrides): Promise<BigNumber>;
        underlying(overrides?: CallOverrides): Promise<BigNumber>;
        uniPair(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        collateralToken(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getIMXLiquidity(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        impermaxBorrow(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, arg2: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        impermaxRedeem(arg0: PromiseOrValue<string>, redeemAmount: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        isInitialized(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        pair(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        sBorrowable(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        short(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        uBorrowable(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        underlying(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        uniPair(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
